/***********************************************************
Copyright 1990 by Digital Equipment Corporation, Maynard, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute these examples for any
purpose and without fee is hereby granted, provided that the above
copyright notice appear in all copies and that both that copyright
notice and this permission notice appear in supporting documentation,
and that the name of Digital not be used in advertising or publicity
pertaining to distribution of the software without specific, written
prior permission.

DIGITAL AND THE AUTHORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS, IN NO EVENT SHALL DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT
OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
OR PERFORMANCE OF THIS SOFTWARE.

******************************************************************/

/* Make these global, we'll need them later.  If this is a multi-
   display application, these must be kept for each display. */
Atom wm_take_focus, wm_save_yourself;

static Atom FetchAtom(w, name)
    Widget w;
    String name;
{
    Atom a;
    XrmValue source, dest;

    source.size = strlen(name)+1;
    source.addr = name;
    dest.size = sizeof(Atom);
    dest.addr = &a;
	
    (void) XtConvertAndStore(w, XtRString, &source, XtRAtom, &dest);
    return a;
}

/* Time to set the protocols */
Atom protocolList[2];

wm_take_focus = FetchAtom(shell, "WM_TAKE_FOCUS");
wm_save_yourself = FetchAtom(shell, "WM_SAVE_YOURSELF");
protocolList[0] = wm_take_focus;
protocolList[1] = wm_save_yourself;

(void) XSetWMProtocols(XtDisplay(shell), XtWindow(shell),
	protocolList, XtNumber(protocolList));
